// MainFrm.cpp : implementation of the CMainFrame class
//
//This is the MainFrm class for the CHummingBirdNT project.  It controls
// the main GUI for the entire project, as well as some record functions
// (I'm trying to change these to the Set class but not be able to - CT 20dec97)
//There are 2 main things to keep in mind that this class controls:
// 1. Splitter windows.
// 2. GUI controls.

#include "stdafx.h"
#include "MainFrm.h"
#include "HummingBirdNT.h"
#include "HummingBirdNTView.h"
#include "HummingBirdNTDoc.h"
#include "HummerTextView.h"
#include "DebugForm.h"

#define PANE_HEIGHT 200		//This is the height of the database form pane (top pane)

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_FORMS_DEBUGFORM, OnFormsDebugform)
	ON_COMMAND(ID_FORMS_MAIN, OnFormsMain)
	ON_COMMAND(ID_RECORD_FIRST, OnRecordFirst)
	ON_COMMAND(ID_RECORD_PREV, OnRecordPrev)
	ON_COMMAND(ID_RECORD_NEXT, OnRecordNext)
	ON_COMMAND(ID_RECORD_LAST, OnRecordLast)
	//}}AFX_MSG_MAP
	// Global help commands
	ON_COMMAND(ID_HELP_FINDER, CFrameWnd::OnHelpFinder)
	ON_COMMAND(ID_HELP, CFrameWnd::OnHelp)
	ON_COMMAND(ID_CONTEXT_HELP, CFrameWnd::OnContextHelp)
	ON_COMMAND(ID_DEFAULT_HELP, CFrameWnd::OnHelpFinder)
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	//Module Description:
	//This function initializes the variables used in the class.
	//
	//Module Specification:
	//As the constructor, this runs when the class is instanciated.
	//
	//Unit Test Details:
	//If the class loads correctly this runs correctly.
	//
	//Internal Data Description:
	//All class variable initial settings are made here.

}

CMainFrame::~CMainFrame()
{
	//Module Description:
	//This function is run when the class is destroyed.  It is up to the programmer
	// to add code here for clean up anything that a simple class destruction
	// doesn't cover.
	//
	//Module Specification:
	//Called when the class is destoyed.
	//
	//Unit Test Details:
	//
	//Internal Data Description:

}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	//Module Description:
	//Created by the Wizard.
	//This creates and loads the GUI objects of the MainFrm.
	//
	//Module Specification:
	//Called on object instatiation.
	//
	//Unit Test Details:
	//None, created by VC++ so assumed to work.
	//
	//Internal Data Description:
	//VC++ Wizard controlled functions and variables.

	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.Create(this) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Remove this if you don't want tool tips or a resizeable toolbar
	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	return 0;
}

BOOL CMainFrame::OnCreateClient( LPCREATESTRUCT /*lpcs*/,
	CCreateContext* pContext)
{
	//Module Description:
	//
	//Module Specification:
	//
	//Unit Test Details:
	//
	//Internal Data Description:

	//Save off the pContext pointer for later use
	static_pContext = pContext;

	//Next set of data is to create the split window GUI.  The HummingBirdNT view for
	// the database forms is on top, and the HummberText view (for output) is on the
	// bottom.
	//The top pane height is specified by PANE_HEIGHT
	VERIFY(m_wndSplitter.CreateStatic(this,2,1));
	if(!m_wndSplitter.CreateView(0,0,RUNTIME_CLASS(CHummingBirdNTView),CSize(0,0),static_pContext)) {
		TRACE0("Failed to CreateView CHummingBirdNTView\n");
		AfxMessageBox("Failed to CreateView CHummingBirdNTView");
		return FALSE;
	} //end if
	if(!m_wndSplitter.CreateView(1,0,RUNTIME_CLASS(CHummerTextView   ),CSize(0,0),static_pContext)) {
		TRACE0("Failed to CreateView CHummerTextView\n");
		AfxMessageBox("Failed to CreateView CHummerTextView");
		return FALSE;
	} //end if

//	CHummingBirdNTView* pWnd = (CHummingBirdNTView *) m_wndSplitter.GetPane(0,0);

	SetActiveView((CView *)m_wndSplitter.GetPane(0,0));
	m_wndSplitter.SetRowInfo(0,PANE_HEIGHT,0);

	m_wndSplitter.ShowWindow(SW_SHOWNORMAL);
	m_wndSplitter.UpdateWindow();

	return TRUE;


//	return m_wndSplitter.Create( this,
//		2, 2,                 // TODO: adjust the number of rows, columns
//		CSize( 10, 10 ),      // TODO: adjust the minimum pane size
//		pContext );
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	//Module Description:
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs
	//
	//Module Specification:
	//Called during object instatiation, before the GUI appears.
	//
	//Unit Test Details:
	//None, VC++ Wizards create this.
	//
	//Internal Data Description:
	//

	return CFrameWnd::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	//Module Description:
	//Asserts itself as valid (I believe when the class is created, as a
	// diagnostic tool).
	//
	//Module Specification:
	//Created by VC++
	//
	//Unit Test Details:
	//If the Form loads this function works.
	//
	//Internal Data Description:
	//None

	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	//Module Description:
	//Dumps the dc (I think it destroys the GUI)
	//
	//Module Specification:
	//Called when the object is destroyed.
	//
	//Unit Test Details:
	//None, created and used by code created by the VC++ Wizards.
	//
	//Internal Data Description:
	//

	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

void CMainFrame::OnFormsMain() 
{
	//Module Description:
	// TODO: Add your command handler code here
	//This is the main record form, and the default.  This function handles
	// the top view form, and replaces it with the Main Form if it is currently
	// holding one of the other forms.  (Main and Debug forms as of 8dec97 - CT).
	//Each of these Forms will have to have their own class, own Dialog box
	// (with flags Style=child and Border=None), and own menu item (currently
	// under "Forms" in the IDR_MAINFRAME, 7oct97 CT).
	//To create this construct:
	// 1. Add a listing to a menu bar.
	// 2. Go to the ClassWizard and add a Messages:Command.
	// 3. That will create this function.
	// 4. Add in a class for that form based off a dialog box form.
	//    Make sure that the class is of form CDaoRecordView with set CHummingBirdNTSet
	//     so that it will have work and have access to the embedded database.
	//    NOTE: If anything is changed or needs to be deleted, go out of the
	//     Developer studio, delete the files, delete the HummingBirdNT.clw file
	//     (make sure it's the .clw file), then go back into the developer.  Now go into
	//     the resource editor.  It will ask you if you want to create a new .clw file.
	//     Make sure to add in the HummingBirdNT.rc file, and choose Yes.
	//     All of this will solve many errors that VC++ creates.
	// 5. Add the header file for that class into the mainfrm.h file.
	// 6. Add code into this function, partially based off of the OnCreateClient function.
	//
	//Module Specification:
	//
	//Unit Test Details:
	//
	//Internal Data Description:


	//First, save off the views to the document


	//Set the new view to a pointer for later use
	//NOTE: This should be the only line that you have to change between forms
	CRuntimeClass* pNewViewClass = RUNTIME_CLASS(CHummingBirdNTView);

	//Set context information
	CCreateContext context=*static_pContext;
	context.m_pNewViewClass = pNewViewClass;
	context.m_pCurrentDoc = GetActiveDocument();

	if(pNewViewClass != NULL) {
		//Delete the view so it can be replaced
		m_wndSplitter.DeleteView(0,0);
		//Now Re-create the pane
		if(!m_wndSplitter.CreateView(0,0,pNewViewClass,CSize(0,0),&context)) {
			TRACE0("Failed to CreateView CHummingBirdNTView\n");
			AfxMessageBox("Failed to CreateView CHummingBirdNTView");
		} //end if

		//The new view is there, but currently invisible and disabled
		SetActiveView((CView *)m_wndSplitter.GetPane(0,0));
		m_wndSplitter.SetRowInfo(0,PANE_HEIGHT,0);	//changes the splitter back to the original height
		m_wndSplitter.ShowWindow(SW_SHOWNORMAL);
		m_wndSplitter.RecalcLayout();				//Recalculate and show after re-setting sizes
		m_wndSplitter.UpdateWindow();	

		//destroy the old view
	} //end if
	
}

void CMainFrame::OnFormsDebugform() 
{
	//Module Description:
	//
	//Module Specification:
	//
	//Unit Test Details:
	//
	//Internal Data Description:

	//This is a form for debugging purposes.

	//First, save off the views to the document
//	CHummingBirdNTDoc* pDoc = GetDocument();
//	pDoc->UpdateAllViews(NULL, 0L, NULL);

	//Set the new view to a pointer for later use
	//NOTE: This should be the only line that you have to change between forms
	CRuntimeClass* pNewViewClass = RUNTIME_CLASS(CDebugForm);

	//Set context information
	CCreateContext context=*static_pContext;
	context.m_pNewViewClass = pNewViewClass;
	context.m_pCurrentDoc = GetActiveDocument();

	if(pNewViewClass != NULL) {
		//Delete the view so it can be replaced
		m_wndSplitter.DeleteView(0,0);
		//Now Re-create the pane
		if(!m_wndSplitter.CreateView(0,0,pNewViewClass,CSize(0,0),&context)) {
			TRACE0("Failed to CreateView CHummingBirdNTView\n");
			AfxMessageBox("Failed to CreateView CHummingBirdNTView");
		} //end if

		//The new view is there, but currently invisible and disabled
		SetActiveView((CView *)m_wndSplitter.GetPane(0,0));
		m_wndSplitter.SetRowInfo(0,PANE_HEIGHT,0);	//changes the splitter back to the original height
		m_wndSplitter.ShowWindow(SW_SHOWNORMAL);
		m_wndSplitter.RecalcLayout();				//Recalculate and show after re-setting sizes
		m_wndSplitter.UpdateWindow();	

		//destroy the old view
	} //end if
	
} //end function: void CMainFrame::OnFormsDebugform() 

void CMainFrame::OnRecordFirst() 
{
	//Module Description:
	// TODO: Add your command handler code here
	//
	//Module Specification:
	//
	//Unit Test Details:
	//
	//Internal Data Description:

}

void CMainFrame::OnRecordPrev() 
{
	//Module Description:
	// TODO: Add your command handler code here
	//
	//Module Specification:
	//
	//Unit Test Details:
	//
	//Internal Data Description:

}

void CMainFrame::OnRecordNext() 
{
	//Module Description:
	// TODO: Add your command handler code here
	//
	//Module Specification:
	//
	//Unit Test Details:
	//
	//Internal Data Description:

}

void CMainFrame::OnRecordLast() 
{
	//Module Description:
	// TODO: Add your command handler code here
	//
	//Module Specification:
	//
	//Unit Test Details:
	//
	//Internal Data Description:

}
